'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MirrorLight = function (_React$Component) {
  _inherits(MirrorLight, _React$Component);

  function MirrorLight() {
    _classCallCheck(this, MirrorLight);

    return _possibleConstructorReturn(this, (MirrorLight.__proto__ || Object.getPrototypeOf(MirrorLight)).apply(this, arguments));
  }

  _createClass(MirrorLight, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          inline = _props.inline,
          codeMirror = _props.codeMirror,
          value = _props.value,
          language = _props.language,
          className = _props.className,
          prefix = _props.prefix,
          theme = _props.theme;

      var elements = [];
      var index = 0;
      var lastStyle = null;
      var tokenBuf = '';
      var pushElement = function pushElement(token, style) {
        elements.push(_react2.default.createElement(
          'span',
          { className: style ? prefix + style : '', key: ++index },
          token
        ));
      };
      var mode = codeMirror.findModeByName(language);
      codeMirror.runMode(value, mode ? mode.mime : language, function (token, style) {
        if (lastStyle === style) {
          tokenBuf += token;
          lastStyle = style;
        } else {
          if (tokenBuf) {
            pushElement(tokenBuf, lastStyle);
          }
          tokenBuf = token;
          lastStyle = style;
        }
      });
      pushElement(tokenBuf, lastStyle);

      var code = _react2.default.createElement(
        'code',
        { className: inline ? 'inline ' + prefix + 's-' + theme : '' },
        elements
      );

      return inline ? code : _react2.default.createElement(
        'pre',
        { className: className + ' ' + prefix + 's-' + theme },
        code
      );
    }
  }]);

  return MirrorLight;
}(_react2.default.Component);

MirrorLight.propTypes = {
  codeMirror: _propTypes2.default.func.isRequired,
  className: _propTypes2.default.string,
  theme: _propTypes2.default.string,
  inline: _propTypes2.default.bool,
  language: _propTypes2.default.string,
  prefix: _propTypes2.default.string,
  value: _propTypes2.default.string.isRequired
};
MirrorLight.defaultProps = {
  className: '',
  prefix: 'cm-'
};
exports.default = MirrorLight;
module.exports = exports['default'];